org.apache.naming.resources

## Class FileDirContext

- java.lang.Object
- - org.apache.naming.resources.BaseDirContext
  - - org.apache.naming.resources.FileDirContext

- All Implemented Interfaces:
    Context, DirContext
  Direct Known Subclasses:
    VirtualDirContext

      public class FileDirContext
      extends BaseDirContext

  Filesystem Directory Context implementation helper class.
  Author:
    Remy Maucherat

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static class` | `FileDirContext.FileResource` This specialized resource implementation avoids opening the InputStream to the file right away (which would put a lock on the file).
    `protected static class` | `FileDirContext.FileResourceAttributes` This specialized resource attribute implementation does some lazy reading (to speed up simple checks, like checking the last modified date).

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected String` | `absoluteBase` Absolute normalized filename of the base.
    `protected boolean` | `allowLinking` Allow linking.
    `protected File` | `base` The document base directory.
    `protected static int` | `BUFFER_SIZE` The descriptive information string for this implementation.

    - ### Fields inherited from class org.apache.naming.resources.BaseDirContext

      `aliases, altDirContexts, cached, cacheMaxSize, cacheObjectMaxSize, cacheTTL, docBase, env, nameParser, sm`

    - ### Fields inherited from interface javax.naming.directory.DirContext

      `ADD_ATTRIBUTE, REMOVE_ATTRIBUTE, REPLACE_ATTRIBUTE`

    - ### Fields inherited from interface javax.naming.Context

      `APPLET, AUTHORITATIVE, BATCHSIZE, DNS_URL, INITIAL_CONTEXT_FACTORY, LANGUAGE, OBJECT_FACTORIES, PROVIDER_URL, REFERRAL, SECURITY_AUTHENTICATION, SECURITY_CREDENTIALS, SECURITY_PRINCIPAL, SECURITY_PROTOCOL, STATE_FACTORIES, URL_PKG_PREFIXES`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FileDirContext()` Builds a file directory context using the given environment.
    `FileDirContext(Hashtable<String,Object> env)` Builds a file directory context using the given environment.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `bind(String name, Object obj, Attributes attrs)` Binds a name to an object, along with associated attributes.
    `DirContext` | `createSubcontext(String name, Attributes attrs)` Creates and binds a new context, along with associated attributes.
    `void` | `destroySubcontext(String name)` Destroys the named context and removes it from the namespace.
    `protected Attributes` | `doGetAttributes(String name, String[] attrIds)` Retrieves selected attributes associated with a named object.
    `protected String` | `doGetRealPath(String path)` Return the real path for a given virtual path, if possible; otherwise return `null`.
    `protected List<NamingEntry>` | `doListBindings(String name)` Enumerates the names bound in the named context, along with the objects bound to them.
    `protected Object` | `doLookup(String name)` Retrieves the named object.
    `protected File` | `file(String name)` Return a File object representing the specified normalized context-relative path if it exists and is readable.
    `protected File` | `file(String name, boolean mustExist)` Return a File object representing the specified normalized context-relative path if it exists and is readable.
    `boolean` | `getAllowLinking()` Is linking allowed.
    `String` | `getNameInNamespace()` Retrieves the full name of this context within its own namespace.
    `DirContext` | `getSchema(String name)` Retrieves the schema associated with the named object.
    `DirContext` | `getSchemaClassDefinition(String name)` Retrieves a context containing the schema objects of the named object's class definitions.
    `protected List<NamingEntry>` | `list(File file)` List the resources which are members of a collection.
    `Object` | `lookupLink(String name)` Retrieves the named object, following links except for the terminal atomic component of the name.
    `void` | `modifyAttributes(String name, int mod_op, Attributes attrs)` Modifies the attributes associated with a named object.
    `void` | `modifyAttributes(String name, ModificationItem[] mods)` Modifies the attributes associated with a named object using an an ordered list of modifications.
    `protected String` | `normalize(String path)` Return a context-relative path, beginning with a "/", that represents the canonical version of the specified path after ".." and "." elements are resolved out.
    `void` | `rebind(String name, Object obj, Attributes attrs)` Binds a name to an object, along with associated attributes, overwriting any existing binding.
    `void` | `release()` Release any resources allocated for this directory context.
    `void` | `rename(String oldName, String newName)` Binds a new name to the object bound to an old name, and unbinds the old name.
    `NamingEnumeration<SearchResult>` | `search(String name, Attributes matchingAttributes)` Searches in a single context for objects that contain a specified set of attributes.
    `NamingEnumeration<SearchResult>` | `search(String name, Attributes matchingAttributes, String[] attributesToReturn)` Searches in a single context for objects that contain a specified set of attributes, and retrieves selected attributes.
    `NamingEnumeration<SearchResult>` | `search(String name, String filterExpr, Object[] filterArgs, SearchControls cons)` Searches in the named context or object for entries that satisfy the given search filter.
    `NamingEnumeration<SearchResult>` | `search(String name, String filter, SearchControls cons)` Searches in the named context or object for entries that satisfy the given search filter.
    `void` | `setAllowLinking(boolean allowLinking)` Set allow linking.
    `void` | `setDocBase(String docBase)` Set the document root.
    `void` | `unbind(String name)` Unbinds the named object.
    `protected File` | `validate(File file, boolean mustExist, String absoluteBase)`

    - ### Methods inherited from class org.apache.naming.resources.BaseDirContext

      `addAlias, addAltDirContext, addResourcesJar, addToEnvironment, allocate, bind, bind, bind, close, composeName, composeName, createSubcontext, createSubcontext, createSubcontext, destroySubcontext, getAliases, getAttributes, getAttributes, getAttributes, getAttributes, getCacheMaxSize, getCacheObjectMaxSize, getCacheTTL, getDocBase, getEnvironment, getNameParser, getNameParser, getRealPath, getSchema, getSchemaClassDefinition, isCached, list, list, listBindings, listBindings, lookup, lookup, lookupLink, modifyAttributes, modifyAttributes, rebind, rebind, rebind, removeAlias, removeFromEnvironment, rename, search, search, search, search, setAliases, setCached, setCacheMaxSize, setCacheObjectMaxSize, setCacheTTL, unbind`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### BUFFER_SIZE

          protected static final int BUFFER_SIZE

      The descriptive information string for this implementation.
      See Also:
        Constant Field Values

    - #### base

          protected File base

      The document base directory.

    - #### absoluteBase

          protected String absoluteBase

      Absolute normalized filename of the base.

    - #### allowLinking

          protected boolean allowLinking

      Allow linking.

  - ### Constructor Detail

    - #### FileDirContext

          public FileDirContext()

      Builds a file directory context using the given environment.

    - #### FileDirContext

          public FileDirContext(Hashtable<String,Object> env)

      Builds a file directory context using the given environment.
      Parameters:
        `env` - The environment with which to build the context

  - ### Method Detail

    - #### setDocBase

          public void setDocBase(String docBase)

      Set the document root.
      Overrides:
        `setDocBase` in class `BaseDirContext`
      Parameters:
        `docBase` - The new document root
      Throws:
        `IllegalArgumentException` - if the specified value is not supported by this implementation
        `IllegalArgumentException` - if this would create a malformed URL

    - #### setAllowLinking

          public void setAllowLinking(boolean allowLinking)

      Set allow linking.
      Parameters:
        `allowLinking` - The new value for the attribute

    - #### getAllowLinking

          public boolean getAllowLinking()

      Is linking allowed.
      Returns:
        `true` is linking is allowed, otherwise `false`

    - #### release

          public void release()

      Release any resources allocated for this directory context.
      Overrides:
        `release` in class `BaseDirContext`

    - #### doGetRealPath

          protected String doGetRealPath(String path)

      Return the real path for a given virtual path, if possible; otherwise return `null`.
      Specified by:
        `doGetRealPath` in class `BaseDirContext`
      Parameters:
        `path` - The path to the desired resource

    - #### doLookup

          protected Object doLookup(String name)

      Retrieves the named object.
      Specified by:
        `doLookup` in class `BaseDirContext`
      Parameters:
        `name` - the name of the object to look up
      Returns:
        the object bound to name

    - #### unbind

          public void unbind(String name)
                      throws NamingException

      Unbinds the named object. Removes the terminal atomic name in name from the target context--that named by all but the terminal atomic part of name.

      This method is idempotent. It succeeds even if the terminal atomic name is not bound in the target context, but throws NameNotFoundException if any of the intermediate contexts do not exist.

      Specified by:
        `unbind` in interface `Context`
      Specified by:
        `unbind` in class `BaseDirContext`
      Parameters:
        `name` - the name to bind; may not be empty
      Throws:
        `NameNotFoundException` - if an intermediate context does not exist
        `NamingException` - if a naming exception is encountered

    - #### rename

          public void rename(String oldName,
                    String newName)
                      throws NamingException

      Binds a new name to the object bound to an old name, and unbinds the old name. Both names are relative to this context. Any attributes associated with the old name become associated with the new name. Intermediate contexts of the old name are not changed.
      Specified by:
        `rename` in interface `Context`
      Specified by:
        `rename` in class `BaseDirContext`
      Parameters:
        `oldName` - the name of the existing binding; may not be empty
        `newName` - the name of the new binding; may not be empty
      Throws:
        `NameAlreadyBoundException` - if newName is already bound
        `NamingException` - if a naming exception is encountered

    - #### doListBindings

          protected List<NamingEntry> doListBindings(String name)
                                              throws NamingException

      Enumerates the names bound in the named context, along with the objects bound to them. The contents of any subcontexts are not included.

      If a binding is added to or removed from this context, its effect on an enumeration previously returned is undefined.

      Specified by:
        `doListBindings` in class `BaseDirContext`
      Parameters:
        `name` - the name of the context to list
      Returns:
        an enumeration of the bindings in this context. Each element of the enumeration is of type Binding.
      Throws:
        `NamingException` - if a naming exception is encountered

    - #### destroySubcontext

          public void destroySubcontext(String name)
                                 throws NamingException

      Destroys the named context and removes it from the namespace. Any attributes associated with the name are also removed. Intermediate contexts are not destroyed.

      This method is idempotent. It succeeds even if the terminal atomic name is not bound in the target context, but throws NameNotFoundException if any of the intermediate contexts do not exist. In a federated naming system, a context from one naming system may be bound to a name in another. One can subsequently look up and perform operations on the foreign context using a composite name. However, an attempt destroy the context using this composite name will fail with NotContextException, because the foreign context is not a "subcontext" of the context in which it is bound. Instead, use unbind() to remove the binding of the foreign context. Destroying the foreign context requires that the destroySubcontext() be performed on a context from the foreign context's "native" naming system.

      Specified by:
        `destroySubcontext` in interface `Context`
      Specified by:
        `destroySubcontext` in class `BaseDirContext`
      Parameters:
        `name` - the name of the context to be destroyed; may not be empty
      Throws:
        `NameNotFoundException` - if an intermediate context does not exist
        `NotContextException` - if the name is bound but does not name a context, or does not name a context of the appropriate type
        `NamingException`

    - #### lookupLink

          public Object lookupLink(String name)
                            throws NamingException

      Retrieves the named object, following links except for the terminal atomic component of the name. If the object bound to name is not a link, returns the object itself.
      Specified by:
        `lookupLink` in interface `Context`
      Specified by:
        `lookupLink` in class `BaseDirContext`
      Parameters:
        `name` - the name of the object to look up
      Returns:
        the object bound to name, not following the terminal link (if any).
      Throws:
        `NamingException` - if a naming exception is encountered

    - #### getNameInNamespace

          public String getNameInNamespace()
                                    throws NamingException

      Retrieves the full name of this context within its own namespace.

      Many naming services have a notion of a "full name" for objects in their respective namespaces. For example, an LDAP entry has a distinguished name, and a DNS record has a fully qualified name. This method allows the client application to retrieve this name. The string returned by this method is not a JNDI composite name and should not be passed directly to context methods. In naming systems for which the notion of full name does not make sense, OperationNotSupportedException is thrown.

      Specified by:
        `getNameInNamespace` in interface `Context`
      Specified by:
        `getNameInNamespace` in class `BaseDirContext`
      Returns:
        this context's name in its own namespace; never null
      Throws:
        `OperationNotSupportedException` - if the naming system does not have the notion of a full name
        `NamingException` - if a naming exception is encountered

    - #### doGetAttributes

          protected Attributes doGetAttributes(String name,
                                   String[] attrIds)
                                        throws NamingException

      Retrieves selected attributes associated with a named object. See the class description regarding attribute models, attribute type names, and operational attributes.
      Specified by:
        `doGetAttributes` in class `BaseDirContext`
      Parameters:
        `name` - the name of the object from which to retrieve attributes
        `attrIds` - the identifiers of the attributes to retrieve. null indicates that all attributes should be retrieved; an empty array indicates that none should be retrieved
      Returns:
        the requested attributes; never null
      Throws:
        `NamingException` - if a naming exception is encountered

    - #### modifyAttributes

          public void modifyAttributes(String name,
                              int mod_op,
                              Attributes attrs)
                                throws NamingException

      Modifies the attributes associated with a named object. The order of the modifications is not specified. Where possible, the modifications are performed atomically.
      Specified by:
        `modifyAttributes` in interface `DirContext`
      Specified by:
        `modifyAttributes` in class `BaseDirContext`
      Parameters:
        `name` - the name of the object whose attributes will be updated
        `mod_op` - the modification operation, one of: ADD_ATTRIBUTE, REPLACE_ATTRIBUTE, REMOVE_ATTRIBUTE
        `attrs` - the attributes to be used for the modification; may not be null
      Throws:
        `AttributeModificationException` - if the modification cannot be completed successfully
        `NamingException` - if a naming exception is encountered

    - #### modifyAttributes

          public void modifyAttributes(String name,
                              ModificationItem[] mods)
                                throws NamingException

      Modifies the attributes associated with a named object using an an ordered list of modifications. The modifications are performed in the order specified. Each modification specifies a modification operation code and an attribute on which to operate. Where possible, the modifications are performed atomically.
      Specified by:
        `modifyAttributes` in interface `DirContext`
      Specified by:
        `modifyAttributes` in class `BaseDirContext`
      Parameters:
        `name` - the name of the object whose attributes will be updated
        `mods` - an ordered sequence of modifications to be performed; may not be null
      Throws:
        `AttributeModificationException` - if the modification cannot be completed successfully
        `NamingException` - if a naming exception is encountered

    - #### bind

          public void bind(String name,
                  Object obj,
                  Attributes attrs)
                    throws NamingException

      Binds a name to an object, along with associated attributes. If attrs is null, the resulting binding will have the attributes associated with obj if obj is a DirContext, and no attributes otherwise. If attrs is non-null, the resulting binding will have attrs as its attributes; any attributes associated with obj are ignored.
      Specified by:
        `bind` in interface `DirContext`
      Specified by:
        `bind` in class `BaseDirContext`
      Parameters:
        `name` - the name to bind; may not be empty
        `obj` - the object to bind; possibly null
        `attrs` - the attributes to associate with the binding
      Throws:
        `NameAlreadyBoundException` - if name is already bound
        `InvalidAttributesException` - if some "mandatory" attributes of the binding are not supplied
        `NamingException` - if a naming exception is encountered

    - #### rebind

          public void rebind(String name,
                    Object obj,
                    Attributes attrs)
                      throws NamingException

      Binds a name to an object, along with associated attributes, overwriting any existing binding. If attrs is null and obj is a DirContext, the attributes from obj are used. If attrs is null and obj is not a DirContext, any existing attributes associated with the object already bound in the directory remain unchanged. If attrs is non-null, any existing attributes associated with the object already bound in the directory are removed and attrs is associated with the named object. If obj is a DirContext and attrs is non-null, the attributes of obj are ignored.
      Specified by:
        `rebind` in interface `DirContext`
      Specified by:
        `rebind` in class `BaseDirContext`
      Parameters:
        `name` - the name to bind; may not be empty
        `obj` - the object to bind; possibly null
        `attrs` - the attributes to associate with the binding
      Throws:
        `InvalidAttributesException` - if some "mandatory" attributes of the binding are not supplied
        `NamingException` - if a naming exception is encountered

    - #### createSubcontext

          public DirContext createSubcontext(String name,
                                    Attributes attrs)
                                      throws NamingException

      Creates and binds a new context, along with associated attributes. This method creates a new subcontext with the given name, binds it in the target context (that named by all but terminal atomic component of the name), and associates the supplied attributes with the newly created object. All intermediate and target contexts must already exist. If attrs is null, this method is equivalent to Context.createSubcontext().
      Specified by:
        `createSubcontext` in interface `DirContext`
      Specified by:
        `createSubcontext` in class `BaseDirContext`
      Parameters:
        `name` - the name of the context to create; may not be empty
        `attrs` - the attributes to associate with the newly created context
      Returns:
        the newly created context
      Throws:
        `NameAlreadyBoundException` - if the name is already bound
        `InvalidAttributesException` - if attrs does not contain all the mandatory attributes required for creation
        `NamingException` - if a naming exception is encountered

    - #### getSchema

          public DirContext getSchema(String name)
                               throws NamingException

      Retrieves the schema associated with the named object. The schema describes rules regarding the structure of the namespace and the attributes stored within it. The schema specifies what types of objects can be added to the directory and where they can be added; what mandatory and optional attributes an object can have. The range of support for schemas is directory-specific.
      Specified by:
        `getSchema` in interface `DirContext`
      Specified by:
        `getSchema` in class `BaseDirContext`
      Parameters:
        `name` - the name of the object whose schema is to be retrieved
      Returns:
        the schema associated with the context; never null
      Throws:
        `OperationNotSupportedException` - if schema not supported
        `NamingException` - if a naming exception is encountered

    - #### getSchemaClassDefinition

          public DirContext getSchemaClassDefinition(String name)
                                              throws NamingException

      Retrieves a context containing the schema objects of the named object's class definitions.
      Specified by:
        `getSchemaClassDefinition` in interface `DirContext`
      Specified by:
        `getSchemaClassDefinition` in class `BaseDirContext`
      Parameters:
        `name` - the name of the object whose object class definition is to be retrieved
      Returns:
        the DirContext containing the named object's class definitions; never null
      Throws:
        `OperationNotSupportedException` - if schema not supported
        `NamingException` - if a naming exception is encountered

    - #### search

          public NamingEnumeration<SearchResult> search(String name,
                                               Attributes matchingAttributes,
                                               String[] attributesToReturn)
                                                 throws NamingException

      Searches in a single context for objects that contain a specified set of attributes, and retrieves selected attributes. The search is performed using the default SearchControls settings.
      Specified by:
        `search` in interface `DirContext`
      Specified by:
        `search` in class `BaseDirContext`
      Parameters:
        `name` - the name of the context to search
        `matchingAttributes` - the attributes to search for. If empty or null, all objects in the target context are returned.
        `attributesToReturn` - the attributes to return. null indicates that all attributes are to be returned; an empty array indicates that none are to be returned.
      Returns:
        a non-null enumeration of SearchResult objects. Each SearchResult contains the attributes identified by attributesToReturn and the name of the corresponding object, named relative to the context named by name.
      Throws:
        `NamingException` - if a naming exception is encountered

    - #### search

          public NamingEnumeration<SearchResult> search(String name,
                                               Attributes matchingAttributes)
                                                 throws NamingException

      Searches in a single context for objects that contain a specified set of attributes. This method returns all the attributes of such objects. It is equivalent to supplying null as the atributesToReturn parameter to the method search(Name, Attributes, String[]).
      Specified by:
        `search` in interface `DirContext`
      Specified by:
        `search` in class `BaseDirContext`
      Parameters:
        `name` - the name of the context to search
        `matchingAttributes` - the attributes to search for. If empty or null, all objects in the target context are returned.
      Returns:
        a non-null enumeration of SearchResult objects. Each SearchResult contains the attributes identified by attributesToReturn and the name of the corresponding object, named relative to the context named by name.
      Throws:
        `NamingException` - if a naming exception is encountered

    - #### search

          public NamingEnumeration<SearchResult> search(String name,
                                               String filter,
                                               SearchControls cons)
                                                 throws NamingException

      Searches in the named context or object for entries that satisfy the given search filter. Performs the search as specified by the search controls.
      Specified by:
        `search` in interface `DirContext`
      Specified by:
        `search` in class `BaseDirContext`
      Parameters:
        `name` - the name of the context or object to search
        `filter` - the filter expression to use for the search; may not be null
        `cons` - the search controls that control the search. If null, the default search controls are used (equivalent to (new SearchControls())).
      Returns:
        an enumeration of SearchResults of the objects that satisfy the filter; never null
      Throws:
        `InvalidSearchFilterException` - if the search filter specified is not supported or understood by the underlying directory
        `InvalidSearchControlsException` - if the search controls contain invalid settings
        `NamingException` - if a naming exception is encountered

    - #### search

          public NamingEnumeration<SearchResult> search(String name,
                                               String filterExpr,
                                               Object[] filterArgs,
                                               SearchControls cons)
                                                 throws NamingException

      Searches in the named context or object for entries that satisfy the given search filter. Performs the search as specified by the search controls.
      Specified by:
        `search` in interface `DirContext`
      Specified by:
        `search` in class `BaseDirContext`
      Parameters:
        `name` - the name of the context or object to search
        `filterExpr` - the filter expression to use for the search. The expression may contain variables of the form "{i}" where i is a nonnegative integer. May not be null.
        `filterArgs` - the array of arguments to substitute for the variables in filterExpr. The value of filterArgs[i] will replace each occurrence of "{i}". If null, equivalent to an empty array.
        `cons` - the search controls that control the search. If null, the default search controls are used (equivalent to (new SearchControls())).
      Returns:
        an enumeration of SearchResults of the objects that satisfy the filter; never null
      Throws:
        `ArrayIndexOutOfBoundsException` - if filterExpr contains {i} expressions where i is outside the bounds of the array filterArgs
        `InvalidSearchControlsException` - if cons contains invalid settings
        `InvalidSearchFilterException` - if filterExpr with filterArgs represents an invalid search filter
        `NamingException` - if a naming exception is encountered

    - #### normalize

          protected String normalize(String path)

      Return a context-relative path, beginning with a "/", that represents the canonical version of the specified path after ".." and "." elements are resolved out. If the specified path attempts to go outside the boundaries of the current context (i.e. too many ".." path elements are present), return `null` instead.
      Parameters:
        `path` - Path to be normalized

    - #### file

          protected File file(String name)

      Return a File object representing the specified normalized context-relative path if it exists and is readable. Otherwise, return `null`.
      Parameters:
        `name` - Normalized context-relative path (with leading '/')

    - #### file

          protected File file(String name,
                  boolean mustExist)

      Return a File object representing the specified normalized context-relative path if it exists and is readable. Otherwise, return `null`.
      Parameters:
        `name` - Normalized context-relative path (with leading '/')
        `mustExist` - Must the specified resource exist?

    - #### validate

          protected File validate(File file,
                      boolean mustExist,
                      String absoluteBase)

    - #### list

          protected List<NamingEntry> list(File file)

      List the resources which are members of a collection.
      Parameters:
        `file` - Collection
      Returns:
        Vector containing NamingEntry objects

Copyright © 2000-2017 Apache Software Foundation. All Rights Reserved.